SystemOrganization addCategory: #TGListModel!

Object subclass: #PureListModel
	instanceVariableNames: 'list selectionIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TGListModel'!

!PureListModel methodsFor: 'testing' stamp: 'HwaJong 11/13/2012 17:48'!
atEnd
	^ self list size = self selectionIndex! !

!PureListModel methodsFor: 'list manipulation' stamp: 'HwaJong 11/13/2012 18:04'!
atEndInsert: anObject

	self insert: anObject at: list size! !

!PureListModel methodsFor: 'private' stamp: 'HwaJong 1/31/2013 10:59'!
correctSelectionIndex
	selectionIndex < 0 ifTrue: [^self selectNone].
	list
		ifNil:[self selectNone]
		ifNotNil: [
			list isEmpty
				ifTrue: [self selectNone]
				ifFalse: [selectionIndex > list size ifTrue: [self selectNone]]].
	! !

!PureListModel methodsFor: 'list manipulation' stamp: 'HwaJong 1/31/2013 10:45'!
delete: anObject
	|delIndex|
	delIndex := list indexOf: anObject.
	list isEmpty ifTrue: [^self].
	list := (list copyFrom: 1 to: delIndex-1), (list copyFrom: delIndex+1 to: list size).
	delIndex < selectionIndex
		ifTrue: [selectionIndex:=selectionIndex-1]
		ifFalse: [
			delIndex = selectionIndex
				ifTrue: [self selectNone]
				ifFalse: []].
	selectionIndex > list size 
		ifTrue: [selectionIndex := list size].! !

!PureListModel methodsFor: 'list manipulation' stamp: 'HwaJong 11/13/2012 17:50'!
deleteSelection

	list isEmpty ifTrue: [^self].
	list := (list copyFrom: 1 to: selectionIndex-1), (list copyFrom: selectionIndex+1 to: list size).
	selectionIndex > list size ifTrue: [selectionIndex := list size].! !

!PureListModel methodsFor: 'testing' stamp: 'HwaJong 11/13/2012 17:52'!
hasSelection

	^list isEmpty not and: [selectionIndex > 0]! !

!PureListModel methodsFor: 'controlling' stamp: 'HwaJong 1/4/2013 11:56'!
ifHasSelection: block1 ifDoesNotHaveSelection: block2
	^self hasSelection
		ifTrue: [block1 value: self selection]
		ifFalse: [block2 value]! !

!PureListModel methodsFor: 'initialization' stamp: 'HwaJong 1/23/2013 11:23'!
initialize

	super initialize.
	list := Array new.
	self selectNone.! !

!PureListModel methodsFor: 'list manipulation' stamp: 'HwaJong 11/13/2012 17:54'!
insert: anObject at: anInteger

	(anInteger between: 1 and: list size)
		ifTrue: [ list := (list copyFrom: 1 to: anInteger), (Array with: anObject), (list copyFrom:anInteger+1 to: list size).
			selectionIndex := anInteger+1]
		ifFalse: [list := Array with: anObject.
			selectionIndex := 1 ].! !

!PureListModel methodsFor: 'list manipulation' stamp: 'HwaJong 11/13/2012 17:54'!
insertAll: anArray at: anInteger

	list := Array streamContents: [:stream| 
		stream nextPutAll: (list copyFrom: 1 to: anInteger).
		stream nextPutAll: anArray.
		stream nextPutAll: (list copyFrom: anInteger+1 to: list size).
		].
	selectionIndex := anInteger + anArray size.

	! !

!PureListModel methodsFor: 'accessing' stamp: 'HwaJong 11/13/2012 17:55'!
list
	^ list! !

!PureListModel methodsFor: 'accessing' stamp: 'HwaJong 1/31/2013 10:40'!
list: anOrderedCollection
	list := anOrderedCollection.
	self correctSelectionIndex
! !

!PureListModel methodsFor: 'list manipulation' stamp: 'HwaJong 11/13/2012 17:56'!
moveSelectionDown

	selectionIndex = list size ifTrue: [^self].
	list swap: selectionIndex with: selectionIndex+1.
	selectionIndex := selectionIndex + 1.! !

!PureListModel methodsFor: 'list manipulation' stamp: 'HwaJong 11/13/2012 17:56'!
moveSelectionUp

	selectionIndex = 1 ifTrue: [^self].
	list swap: selectionIndex-1 with: selectionIndex.
	selectionIndex := selectionIndex-1.! !

!PureListModel methodsFor: 'testing' stamp: 'HwaJong 11/13/2012 18:02'!
notEmpty
^list notEmpty! !

!PureListModel methodsFor: 'initialization' stamp: 'HwaJong 1/23/2013 11:16'!
selectNone
	selectionIndex := 0! !

!PureListModel methodsFor: 'self evaluating' stamp: 'HwaJong 11/13/2012 18:00'!
selection
	^self list at: self selectionIndex! !

!PureListModel methodsFor: 'accessing' stamp: 'HwaJong 11/13/2012 17:57'!
selectionIndex
	^ selectionIndex! !

!PureListModel methodsFor: 'accessing' stamp: 'HwaJong 11/13/2012 17:57'!
selectionIndex: anInteger
	selectionIndex := anInteger
! !

PureListModel subclass: #TGListModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TGListModel'!

!TGListModel methodsFor: 'list manipulation' stamp: 'HwaJong 12/8/2012 11:27'!
insertAfterSelection: anObject 
	self insert: anObject at: selectionIndex	! !

!TGListModel methodsFor: 'accessing' stamp: 'hjo 8/27/2012 19:33'!
objectsForListItems
	^ list! !

PureListModel subclass: #TGListModelPluggableItemPrinting
	instanceVariableNames: 'itemPrintBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TGListModel'!

!TGListModelPluggableItemPrinting methodsFor: 'accessing' stamp: 'hjo 8/25/2012 12:25'!
itemPrintBlock

	itemPrintBlock isNil ifTrue: [ itemPrintBlock := [:obj| obj] ].
	^itemPrintBlock! !

!TGListModelPluggableItemPrinting methodsFor: 'accessing' stamp: 'hjo 8/25/2012 12:26'!
itemPrintBlock: aBlock

	itemPrintBlock := aBlock
	! !

!TGListModelPluggableItemPrinting methodsFor: 'accessing' stamp: 'hjo 8/27/2012 19:33'!
objectsForListItems
	^ list collect: [:each| itemPrintBlock value: each ]! !

TestCase subclass: #TGListModelTest
	instanceVariableNames: 'lm'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TGListModel'!

!TGListModelTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/31/2013 11:05'!
testDelete

	lm := TGListModel new.
	lm list: 'abcde'.
	lm selectionIndex: 3.
	self assert: lm selection equals: $c.
	lm delete: $b.
	self assert: lm list equals: 'acde'.
	self assert: lm selection equals: $c.
	self assert: lm selectionIndex equals: 2.
	
	lm := TGListModel new.
	lm list: 'abcde'.
	lm selectionIndex: 3.
	self assert: lm selection equals: $c.
	lm delete: $d.
	self assert: lm list equals: 'abce'.
	self assert: lm selection equals: $c.
	self assert: lm selectionIndex equals: 3.
	
	lm := TGListModel new.
	lm list: 'abcde'.
	lm selectionIndex: 3.
	self assert: lm selection equals: $c.
	lm delete: $c.
	self assert: lm list equals: 'abde'.
	self deny: lm hasSelection
! !

!TGListModelTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/14/2012 19:42'!
testDeleteSelection

	lm := TGListModel new.
	lm list: {1. 2. 3}.
	lm selectionIndex: 3.
	lm deleteSelection.
	self assert: {1. 2} equals: lm list.
	self assert: 2 equals: lm selectionIndex.
	lm deleteSelection.	
	self assert: {1} equals: lm list.
	self assert: 1 equals: lm selectionIndex.
	lm deleteSelection.	
	self assert: {} equals: lm list.
	self assert: 0 equals: lm selectionIndex.
	"sanity test"
	lm insert: 100 at: 1.
	self assert: {100} equals: lm list.
	self assert: 1 equals: lm selectionIndex.
! !

!TGListModelTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/14/2012 19:49'!
testInsertAllAt

	lm := TGListModel new.
	lm list: {1. 2. 3. 4. 5}.
	lm selectionIndex: 3.
	lm insertAll: {6. 7. 8. 9} at: 4.
	self assert: {1. 2. 3. 4. 6. 7. 8. 9. 5} equals: lm list.
	self assert: 8 equals: lm selectionIndex.
! !

!TGListModelTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/14/2012 19:35'!
testInsertAt

	lm := TGListModel new.
	lm insert: 'hi' at: 1.
	self assert: {'hi'} equals: lm list.
	self assert: 1 equals: lm selectionIndex.
	lm insert: 'there' at: 1.
	self assert: {'hi'. 'there'} equals: lm list.
	self assert: 2 equals: lm selectionIndex.
	lm insert: 'you' at: 1.
	self assert: {'hi'. 'you'. 'there'} equals: lm list.
	self assert: 2 equals: lm selectionIndex.
	lm insert: 'lala' at: 3.
	self assert: {'hi'. 'you'. 'there'. 'lala'} equals: lm list.
	self assert: 4 equals: lm selectionIndex.
! !

!TGListModelTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/14/2012 18:31'!
testInsertInsaneIndex

	lm := TGListModel new.
	lm insert: 'hi' at: 29.
	self assert: {'hi'} equals: lm list.
	self assert: 1 equals: lm selectionIndex.! !

!TGListModelTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/14/2012 18:38'!
testMoveSelectionDown

	lm := TGListModel new.
	lm list: {1. 2. 3. 4. 5}.
	lm selectionIndex: 3.
	lm moveSelectionDown.	
	self assert: {1. 2. 4. 3. 5} equals: lm list.
	self assert: 4 equals: lm selectionIndex.
	lm moveSelectionDown.
	self assert: {1. 2. 4. 5. 3} equals: lm list.
	self assert: 5 equals: lm selectionIndex.
	lm moveSelectionDown.
	self assert: {1. 2. 4. 5. 3} equals: lm list.
	self assert: 5 equals: lm selectionIndex.
! !

!TGListModelTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/14/2012 18:37'!
testMoveSelectionUp

	lm := TGListModel new.
	lm list: {1. 2. 3. 4. 5}.
	lm selectionIndex: 3.
	lm moveSelectionUp.	
	self assert: {1. 3. 2. 4. 5} equals: lm list.
	self assert: 2 equals: lm selectionIndex.
	lm moveSelectionUp.
	self assert: {3. 1. 2. 4. 5} equals: lm list.
	self assert: 1 equals: lm selectionIndex.
	lm moveSelectionUp.
	self assert: {3. 1. 2. 4. 5} equals: lm list.
	self assert: 1 equals: lm selectionIndex.! !

!TGListModelTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/14/2012 18:40'!
testMoveSelectionUpDownWithOneItem

	lm := TGListModel new.
	lm list: {3}.
	lm selectionIndex: 1.
	lm moveSelectionUp.
	self assert: {3} equals: lm list.
	self assert: 1 equals: lm selectionIndex.
	lm moveSelectionDown.
	self assert: {3} equals: lm list.
	self assert: 1 equals: lm selectionIndex.
! !

!TGListModelTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/31/2013 11:00'!
testSettingListCorrectsSelectionIndex

	lm := TGListModel new.
	lm selectionIndex: 2900.
	self assert: lm selectionIndex equals: 2900.
	lm list: {}.
	self assert: lm selectionIndex equals: 0.
	
	lm := TGListModel new.
	lm selectionIndex: 2900.
	self assert: lm selectionIndex equals: 2900.
	lm list: nil.
	self assert: lm selectionIndex equals: 0.
	
	lm := TGListModel new.
	lm selectionIndex: 2900.
	self assert: lm selectionIndex equals: 2900.
	lm list: {1. 2. 3}.
	self assert: lm selectionIndex equals: 0.! !
